﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;
using System.ServiceModel.Activation;
using System.ServiceModel.Description;

namespace WcfService3
{
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the class name "Service1" in code, svc and config file together.
    public class Service3 : IService3
    {
        public string GetData(int value)
        {
            return string.Format("Dinamically, You entered: {0}", value);
        }

        public CompositeType GetDataUsingDataContract(CompositeType composite)
        {
            if (composite == null)
            {
                throw new ArgumentNullException("composite");
            }
            if (composite.BoolValue)
            {
                composite.StringValue += "Suffix";
            }
            return composite;
        }
    }

    public class Service3Factory : ServiceHostFactory
    {
        protected override ServiceHost CreateServiceHost(Type serviceType, Uri[] baseAddresses)
        {
            ServiceHost host = base.CreateServiceHost(serviceType, baseAddresses);
            // We can customize our service here adding or changing service behaviors, inspectors, etc.
            //host.AddServiceEndpoint("IService3", new NetTcpBinding(), "");
            //host.Description.Behaviors.Add(new ServiceDebugBehavior(){ HttpHelpPageEnabled=true, IncludeExceptionDetailInFaults=true});
            //host.Description.Endpoints.Add(new ServiceEndpoint(new ContractDescription("IService3"), new NetTcpBinding(), new EndpointAddress("net.tcp://andres-pdc/WcfService1/Service3.svc")));
            return host;
        }
    }
}
